/**
 * fluent-adflow-widget.js
 *
 * Licensed under the Fluent Software Development Kit (SDK) Terms of Use
 * Version 1.0 (the "License");
 *
 * You may not use this file except in compliance with the License.
 *
 * You may obtain a copy of the License at https://fluentco.com
 */

import { requireNativeComponent, NativeEventEmitter, NativeModules } from 'react-native';
import React, { Component } from 'react';
import packageJson from '../package.json';
const eventManagerEmitter = new NativeEventEmitter(NativeModules.AdsViewEventEmitter);
const packageName = packageJson.name;
const packageVersion = packageJson.version;
export class FluentAdFlowWidgetView extends Component {
  subscriberOnAdFlowContainerClosed = eventManagerEmitter.addListener("onAdFlowContainerClosed", result => {
    this.props.onAdShow && this.props.onAdShow(false);
    if (__DEV__) {
      console.log(">> onAdFlowContainerClosed -> ", result);
    }
    this.setState({
      height: 0
    });
  });
  subscriberOnAdFlowContainerShow = eventManagerEmitter.addListener("onAdFlowContainerShow", result => {
    if (__DEV__) {
      console.log(">> onAdFlowContainerShow -> ", result);
    }
    this.props.onAdShow && this.props.onAdShow(true);
    // this.setState({height: this.props.style.height})
  });

  subscriberOnAdFlowContainerHeightChanged = eventManagerEmitter.addListener("onAdFlowContainerHeightChanged", result => {
    if (__DEV__) {
      console.log(">> onAdFlowContainerHeightChanged -> ", result);
    }
    this.setState({
      height: parseInt(result)
    });
  });
  subscriberOnError = eventManagerEmitter.addListener("onError", result => {
    if (__DEV__) {
      console.log(">> onError -> ", result);
    }
    this.setState({
      height: 0
    });
  });
  subscriberOnValidationFailed = eventManagerEmitter.addListener("onValidationFailed", result => {
    if (__DEV__) {
      console.log(">> onError -> ", result);
    }
  });
  subscriberOnNotified = eventManagerEmitter.addListener("onNotified", result => {
    if (__DEV__) {
      console.log(">> onNotified -> ", result);
    }
  });
  constructor(props) {
    super(props);
    this.state = {
      height: 0
    };
  }
  render() {
    return /*#__PURE__*/React.createElement(WidgetNativeComponent, {
      style: [this.props.style, {
        height: this.state.height
      }],
      params: this.props.params,
      wrapperName: packageName,
      wrapperVersion: packageVersion
    });
  }
  componentWillUnmount() {
    this.subscriberOnAdFlowContainerClosed.remove();
    this.subscriberOnAdFlowContainerShow.remove();
    this.subscriberOnAdFlowContainerHeightChanged.remove();
    this.subscriberOnError.remove();
    this.subscriberOnValidationFailed.remove();
    this.subscriberOnNotified.remove();
  }
}
export const WidgetNativeComponent = requireNativeComponent('FluentAdFlowWidgetView');
export default FluentAdFlowWidgetView;
//# sourceMappingURL=fluent-adflow-widget.js.map